﻿Type=Activity
Version=7.28
ModulesStructureVersion=1
B4A=true
@EndOfDesignText@
#Region  Activity Attributes 
	#FullScreen: False
	#IncludeTitle: True
#End Region

Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'These variables can be accessed from all modules.
	Dim codigoConf As String = ""
	Dim plataforma As String = "5" '5 = Plataforma de numero corto, 3 = Numero largo
End Sub

Sub Globals
	'These global variables will be redeclared each time the activity is created.
	'These variables can only be accessed from this module.
	Private btnConfirmar As Button
	Private btnEnviarCodigo As Button
	Private Label1 As Label
	Private Label2 As Label
	Private Label3 As Label
	Private txtCel01 As EditText
	Private txtCel02 As EditText
	Private txtCodigo As EditText
End Sub

Sub Activity_Create(FirstTime As Boolean)
	'Do not forget to load the layout file created with the visual designer. For example:
	Activity.LoadLayout("configuracion")
	Activity.Title = "Configuración easypoll"
	
	If FirstTime Then txtCel01.RequestFocus
	If codigoConf<>"" Then 
		btnEnviarCodigo.Visible=False
		txtCodigo.Enabled = True
		txtCodigo.RequestFocus
		btnConfirmar.Enabled = True
	End If
End Sub

Sub Activity_Resume
	If File.Exists(File.DirInternal,"config.dat") Then
		Dim raf As RandomAccessFile
		Dim List As List
		List.Initialize
		raf.Initialize(File.DirInternal,"config.dat",False)
		List = raf.ReadEncryptedObject(Starter.passWord, 0)
		Log(List)
		codigoConf = List.Get(3)
		txtCel01.Visible = False
		txtCel02.Visible = False
		btnEnviarCodigo.Visible = False
		btnConfirmar.Enabled = True
		txtCodigo.Enabled=True
		raf.Close
	End If
End Sub

Sub Activity_Pause (UserClosed As Boolean)
	If UserClosed Then
		
	End If
End Sub

Sub IniciaConfig
    	
	If File.Exists(File.DirInternal,"config.dat") = False Then
		' ######## Estructura config.dat
		' 0-CelId
		' 1-SimId
		' 2-NumeroCel
		' 3-CodigoSms
		' 4-NumeroCelTempo
		' Inicia List
		Dim List As List
		List.Initialize
		List.Add("CelId")		'0
		List.Add("SimId")		'1
		List.Add("NumeroCel")	'2
		List.Add("CodigoSms")	'3
		List.Add("NumeroCelTempo") '4
			
		Dim raf As RandomAccessFile
		raf.Initialize(File.DirInternal,"config.dat",False)
		raf.WriteEncryptedObject(List,Starter.passWord, 0)
		raf.Close
		Log("IniciaConfig")
	End If
	'Activity.Finish
End Sub

Sub GuardacodigoConf(completo As Boolean) 
	' Inicia config.dat y guarda el telefono x confirmar mediante SMS
	' Guarda celId, simId, codigo de 4 digitos y numero de telefono x confirmar
	If completo = False Then IniciaConfig

	Dim Phone As PhoneId
	Dim raf As RandomAccessFile
	If File.Exists(File.DirInternal,"config.dat") Then
		raf.Initialize(File.DirInternal,"config.dat",False)
		Dim List As List
		List.Initialize
		List = raf.ReadEncryptedObject(Starter.passWord,0)
		
		Starter.celId = Phone.GetDeviceId
		Starter.simId = Phone.GetSimSerialNumber
		Starter.numCel = txtCel01.Text
		
		List.Set(0, Starter.celId)
		List.Set(1, Starter.simId)
		List.Set(3, codigoConf)
		List.Set(4, txtCel01.Text)
		If completo Then List.Set(2,List.Get(4)) 'hasta que reciba el SMS guarda cel
		raf.WriteEncryptedObject(List, Starter.passWord, 0)
		raf.Close
		Log(List)
	End If
	
End Sub

Sub btnEnviarCodigo_Click
	If txtCel01.Text = txtCel02.Text Then
	 	btnEnviarCodigo.Visible = False
		Dim jobsms As HttpJob
		jobsms.Initialize("jobsms",Me)
	 	codigoConf = Rnd(0,10) & Rnd(0,10) & Rnd(0,10) & Rnd(0,10)
	 	Log(codigoConf)
	 	Dim mensaje As String = "BIENVENIDO a " & Starter.nomapp & " - Introduzca el siguiente codigo de 4 digitos, para confirmar su numero de celular: " & codigoConf
	 	Dim PostString As String = "username=ALESCA&password=ESCALANTE&message=" & mensaje & "&numbers=" & txtCel01.Text & "&platform=" & plataforma
		Log(PostString)
		jobsms.PostString(Starter.urlsms,PostString)
	Else
		Msgbox("No coinciden los números verifique",Starter.nomApp)
	End If
End Sub

Sub JobDone(job As HttpJob)
	Dim s As String = ""
	Select Case job.JobName
		Case "jobsms"
		If job.Success Then
			s = job.GetString
			Log(s)
			If s.IndexOf("<status>OK<")<>0 Then
			 	Msgbox("En unos instantes recibirá un SMS con su código de activación(CUATRO DIGITOS)",Starter.nomApp)
				btnConfirmar.Enabled = True
				txtCodigo.Enabled = True
				txtCodigo.RequestFocus
				txtCel01.Enabled = False
				txtCel02.Enabled = False
				GuardacodigoConf(False)
			Else
				Msgbox("Error de comunicación, intente de nuevo","Kerberos")
				btnEnviarCodigo.Visible = True
			End If
		Else
				Msgbox("No cuenta con una conexión a internet, intente mas tarde.",Starter.nomApp)
			btnEnviarCodigo.Visible = True
		End If
		Case "jobkerberos"
		If job.Success Then
			s = job.GetString			
			s = s.SubString2(0,s.IndexOf("***"))
			If s.IndexOf("OK") > -1 Then
				Msgbox("Configuración éxitosa",Starter.nomApp)
				GuardacodigoConf(True)
				StartActivity("Main")
			Else
				Msgbox(s,"Kerberos")
			End If
			Activity.Finish
		Else
				Msgbox("No cuenta con una conexión a internet, intente mas tarde.",Starter.nomApp)
		End If
	End Select
End Sub

Sub btnConfirmar_Click
	If txtCodigo.Text = codigoConf Then 'codigoConf Then
		' Guarda telefono confirmado 
		If File.Exists(File.DirInternal,"config.dat") Then
			Dim raf As RandomAccessFile
			raf.Initialize(File.DirInternal,"config.dat",False)
			Dim List As List
			List.Initialize
			List = raf.ReadEncryptedObject(Starter.passWord,0)
			
			Dim celTempo As String = List.Get(4)
			Dim numCelMask As String = ""
			numCelMask = "(" & celTempo.SubString2(0,3) & ") " & celTempo.SubString2(3,6) & "-" & celTempo.SubString(6)
			
			
			List.Set(3,numCelMask)
			raf.WriteEncryptedObject(List, Starter.passWord, 0)
			raf.Close
			Log(List)
		
			'Dim job As HttpJob
			'job.Initialize("jobkerberos",Me)
			'Dim postString As String = "altadatos=1&numCel=" & List.Get(7) & "&celId=" & List.Get(0) & "&simId=" & List.Get(1)
			'Log("altadatos=1&numCel=" & List.Get(7) & "&celId=" & List.Get(0) & "&simId=" & List.Get(1))
			'job.PostString(Starter.urleasypoll,postString)
			Msgbox("Configuración éxitosa",Starter.nomApp)
			GuardacodigoConf(True)
			StartActivity("Main")
			Activity.Finish
		End If
	Else
		Msgbox("No coincide el código, intente de nuevo",Starter.nomApp)
	End If 
End Sub

Sub txtCel02_TextChanged (Old As String, New As String)
	If txtCel02.Text = txtCel01.Text Then
	 btnEnviarCodigo.Enabled = True
	End If
	
	If New.Length > 10 Then
	 	txtCel02.Text = Old
		txtCel02.SelectionStart = Old.Length
	End If
	
	If New.Length = 10 And txtCel01.Text<>txtCel02.Text Then
		Msgbox("Los numeros no son iguales, verifique",Starter.nomApp)
	End If
End Sub

Sub txtCel01_TextChanged (Old As String, New As String)
	If New.Length = 10 Then
		'txtCel01.Enabled = False
	 	'txtCel02.Enabled = True
	 	txtCel02.RequestFocus
	End If
	If New.Length > 10 Then
	 	txtCel01.Text = Old
	End If
End Sub

Sub txtCodigo_TextChanged (Old As String, New As String)
	If New.Length > 4 Then
	 	txtCodigo.Text = Old
		txtCodigo.SelectionStart = Old.Length
	End If
End Sub